unit KA.Data.SQL.AdoNetReg;
interface

Uses
   Borland.Vcl.Classes,
   Borland.Vcl.Design.DesignIntf,
   Borland.Vcl.Design.DesignEditors;


Type
  TTableNameEditor = class(TStringProperty)
    Public
      Procedure GetValues( Proc: TGetStrProc); override;
      Function  GetAttributes: TPropertyAttributes; override;
    End;

 TConnectionEditor = class(TStringProperty)
    Public
      Procedure Edit;override;
      Function  GetAttributes: TPropertyAttributes; override;
    End;


procedure Register;

Implementation
Uses
  Borland.Vcl.SysUtils,
  System.Data,
  System.Data.SqlClient,
  KA.Data.SQL.AdoNet;

Procedure TTableNameEditor.GetValues( Proc: TGetStrProc);
Var
  DBase : TKASQLAdoNet;
  X     : Integer;
  SL    : TStringList;
Begin
  if GetComponent(0) is TKASQLAdoNet then
  Begin
    DBase := TKASQLAdoNet(GetComponent(0));
    if DBase.ConnectionString <> '' Then
       Begin
         SL := TStringList.Create;
         Try
           SL.Assign(DBase.Tables);
           For X := 0 To SL.Count-1 do
               Begin
                 Proc(SL.Strings[X]);
               End;
         Finally
           SL.Free;
         End;
       End;
  End;
End;

Function TTableNameEditor.GetAttributes: TPropertyAttributes;
Begin
  Result:= Inherited GetAttributes + [paValueList, paSortList];
End;

{ TConnectionEditor }
function TConnectionEditor.GetAttributes: TPropertyAttributes;
begin
  Result:= [paDialog];
end;

procedure TConnectionEditor.Edit;
Var
  DBase : TKASQLAdoNet;
  R     : String;
begin
  if GetComponent(0) is TKASQLAdoNet then
     Begin
       DBase  := TKASQLAdoNet(GetComponent(0));
       R      := DBase.ConnectionString;
       Try
         R      := DBase.PromptEditor(R);
         if R <> '' Then
            Begin
              DBase.ConnectionString := R;
              Modified;
            End;  
       Except
       End;
     End;
end;


procedure Register;
begin
 RegisterPropertyEditor(TypeInfo(String),TKASQLAdoNet,'TableName',TTableNameEditor);
 RegisterPropertyEditor(TypeInfo(String),TKASQLAdoNet,'ConnectionString',TConnectionEditor);
End;

end.
